/*
 * Copyright (c) 2008-2010, Atheros Communications Inc.
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __FWD_HORNET_
#define __FWD_HORNET_

#include <hif_usb.h>
#include <hif_api.h>

/* fwd specific data - begin */

#define MAX_NUM_OF_FW_STAGES  2
#define FWD_MAX_CHUNK           4096


typedef struct {
 hif_handle_t      hif_handle;     /* which i/f              */
 a_uint8_t      *image;         /* ptr to the image       */
 a_uint8_t	 target_type;
 a_uint32_t*      target_upload_addr;
 a_uint32_t      target_exec_addr[MAX_NUM_OF_FW_STAGES];
 a_uint8_t         current_stage;
 a_uint8_t 	  total_stages;
 unsigned char*   fw_images[MAX_NUM_OF_FW_STAGES];
 unsigned long    fw_size[MAX_NUM_OF_FW_STAGES];
 a_uint32_t      size;           /* total image size       */
 a_uint32_t      offset;         /* current offset         */
} fwd_softc_t;






#endif
